
Foreman - Bug #14458

Taxonomy search should search with STI base class

04/04/2016 09:26 AM - Shlomi Zadok

Status: Closed   

Priority: Normal   

Assignee: Marek Hulán   

Category: Organizations and Locations   

Target version: 1.11.1   

Difficulty:  Fixed in Releases:  

Triaged:  Found in Releases: Nightly

Bugzilla link:  Red Hat JIRA:  

Pull request: https://github.com/theforeman/foreman/p

ull/3389

  

Description

When searching with taxonomy scope, We are looking by model name. This may cause no results if the model is an STI child as the

inner_select method adds the model.name (ArfReport) and not the base class name ("Report", which is what is saved in the

taxable_taxonomies).

https://github.com/theforeman/foreman/blob/develop/app/models/concerns/taxonomix.rb#L99-L113

A possible solution: condition should change to self.base_class.name

If it is an STI it will call the parent name. If not an STI, it will call itself (current behavior).

Example: https://github.com/theforeman/foreman_openscap/pull/157/files#diff-219a837adc650cf4c4ceae3c8a76eb7dR176

Related issues:

Related to OpenSCAP - Bug #14446: compliance reports from a particular org sh... Resolved 04/04/2016

Associated revisions

Revision d96297b1 - 04/05/2016 03:56 AM - Marek Hulán

Fixes #14458 - use a base class for STI taxable objects

Revision f71f5493 - 04/18/2016 01:45 PM - Marek Hulán

Fixes #14458 - use a base class for STI taxable objects

(cherry picked from commit d96297b17f55469e3c49c90979cbd004d80f461c)

History

#1 - 04/04/2016 10:03 AM - Marek Hulán

- Tracker changed from Refactor to Bug

- Status changed from New to Assigned

- Assignee set to Marek Hulán

This was found in foreman_openscap plugin to get an idea you could imagine the issue with core models like this

User.current = User.first

Organization.current = Organization.first

Location.current = Location.first

# loads all libvirts associated with first org and loc

# through TaxableTaxonomy which has column taxable_type that 

# specifies object class - Foreman::Model::Libvirt in this case

Foreman::Model::Libvirt.all 

 supposing you have some libvirt associated to selected orgs and locs you'll still see [] as result since it uses Foreman::Model::Libvirt for taxable_type

column in SQL query. Well, in this case it actually works because Taxonomix is included in ComputeResource  directly so the same name is stored in

taxable_type but if you think about model that is inherited in a plugin and adds taxonomies, it does not work.

#2 - 04/04/2016 10:41 AM - The Foreman Bot
https://github.com/theforeman/foreman/blob/develop/app/models/concerns/taxonomix.rb#L99-L113
https://github.com/theforeman/foreman_openscap/pull/157/files#diff-219a837adc650cf4c4ceae3c8a76eb7dR176


- Status changed from Assigned to Ready For Testing

- Pull request https://github.com/theforeman/foreman/pull/3389 added

#3 - 04/05/2016 04:01 AM - Marek Hulán

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset d96297b17f55469e3c49c90979cbd004d80f461c.

#4 - 04/05/2016 10:52 AM - Dominic Cleal

- translation missing: en.field_release set to 141

#5 - 04/06/2016 04:13 AM - Marek Hulán

- Related to Bug #14446: compliance reports from a particular org should be visible when org context is set added
